  //----------------------------------------------------------------------------------
//    Multi Band DDS VFO Ver3.1        
//                         JA2NKD 2016.10.19 
//                         JA2GQP 2016/10/23
//    MOD by OZ6YK         2022.09.12 To singel band trx 50 or 70 MHz
//     remember to uploade vfo_6_4m_eep befor uploading this.
//    go to "Initialization  Program" to change romadd if you will switch between 50 and 70 Mhz
//
//     Aruduino IDE 1.8.2
//     Arduino UNO
//     
// <Rotary.h>    https://github.com/brianlow/Rotary
// 
// "Ucglib.h"    https://github.com/olikraus/ucglib
// "si5351ajk.h"   https://kuepper.dk/?page_id=129
//---------------------------------------------------------------------------------
// si5351a transplant  2016/10/23  JA2GQP
//       (si5351a.h is original hedder file.)
//  now si5351ajk.h because of the use of BFO
//---------------------------------------------------------------------------------

//---------- Library include ----------

#include "si5351jk.h"                      // 2016/10/23 JA2GQP
#include <SPI.h>
#include <EEPROM.h>
#include "Rotary.h"
#include "Ucglib.h"


// I/O setting
 
  const byte __CS=10;
  const byte __DC=9;
  const byte __RST=8;


const byte txout=12;                      // 
  const byte txsw=A3;                       //  
  const byte meterin=A0;                    // 
  const byte analogsw=A1;                   // 
  

  Rotary r=Rotary(2,3);
  Ucglib_ILI9341_18x240x320_HWSPI ucg(__DC, __CS, __RST);
  
 


//----------- Default Frequency Value --------------------

#define   UPPER      0                    // Upoper heterodyne
#define   LOWER      1                    // Lower heterodyne
 


//----------- Default ETC. Value --------------------

#define   DEF_STP    100L                 // Init STEP  2019.01.31 OZ6YK
#define   DEF_Mode   0                    // 0=LSB 1=USB 2=CW 3=AM

//----------  Memory Assign  ------------------


long ifshiftb;

byte Byt_Chn;                             // Channel SW   2019.01.31 OZ6YK
byte Byt_Chnb;                            //            Old
int_fast32_t timepassed;                  // int to hold the arduino miilis since startup
int Flg_eepWT = 0;                        // EEP Wite Flag 

//---------- Variable setting ----------

  long romf[4];
  long freq =7020000;
  long freqmax=71000000;
  long freqmin=69800000;
  long freqold=0;
  long freqrit=0;

  String freqt=String(freq);

  long ifshift = 0;

   long ifshiftLSB =7998500; // VFO>frequency USB/LSB is turn over
  long ifshiftUSB =8001500;  // the IF has been chosen because I had a lot of 8MHz x-tals
  long ifshiftCW  =7999200;
  long ifshiftAM  =8000000;  
  long txshiftLSB =7998500;
  long txshiftUSB =8001500;
  long txshiftCW  =8000000;
  long txshiftAM  =8000000;

  long ddsfreq = 0;
  long ddsfreqb;           // 2016/10/23 JA2GQP
byte   hetero = UPPER;                    // Lower heterodyne set
  char f100m,f10m,fmega,f100k,f10k,f1k,f100,f10,f1;

  int ddsstep=2;
  int rit=0;
  int fstep=100;
  int steprom=1;
  int fmode=3;
  int fmodeold=1;
  int flagrit=0;
  int fritold=0;
  int flagmode=0;
  int meterval1=0;
  int tmeterval=0;
  int romadd=0;
  int analogdata=0;
  int band=0;
  int bandmax=10;  

//----------  Initialization  Program  ----------------------
 
void setup() {
 i2cInit();                             // I2c initialaz  2016/10/23 JA2GQP
  
  delay(100);
  ucg.begin(UCG_FONT_MODE_TRANSPARENT);
  ucg.clearScreen();
  ucg.setRotate270();

  pinMode(txsw,INPUT_PULLUP);

  
  PCICR |=(1<<PCIE2);
  PCMSK2 |=(1 << PCINT18) | (1 << PCINT19);
  sei();



  band=EEPROM.read(0x01);
 
  romadd=0x020; // if 50 Mhz set romadd=0x010 if 70 Mhz romadd=0x020
  for (int i=0; i<3;i++){
   romf[i]=eepread((romadd+4*i));
  }
  freq = romf[0];
  freqmin = romf[1];
  freqmax = romf[2];
  fmode = EEPROM.read(romadd+12);
  steprom = EEPROM.read(romadd+13);
  if (steprom==1){fstep=10;}
  if (steprom==2){fstep=100;}
  if (steprom==3){fstep=1000;}
  if (steprom==4){fstep=10000;}

  screen01();
  if (fmode==0){fmode=3;}
  else{fmode=fmode-1;}
  modeset();
  steplcd();
  freqt=String(freq);
  freqlcd();
}

//----------  Main program  ---------------------------------
 
void loop() {

  analogdata=analogRead(analogsw);

   
    if (analogdata<50){                    
      setstep();
    } else if (analogdata<300){             
      modeset();
    } else if (analogdata<600){             
      setrit();

    }
  if (digitalRead(txsw)==LOW){txset();}
  if (flagrit==1){
    if (freqrit == fritold){
      meter();
    }    
    if (freqrit!=fritold){
      ddswrite();
      ritlcd();
      fritold=freqrit;  
    }
  }
  else{
    if (freq == freqold){
        meter();
    }
  ddswrite();
  freqt=String(freq); 
  freqlcd();
  freqold=freq;
  }
}

//----------  Function DDS set  --------------- 2016/10/23  JA2GQP        

void Fnc_Dds(long frequency){
  if(ddsfreq != ddsfreqb){
    si5351aSetFrequency(frequency);
  SetPower(1);
    ddsfreqb = ddsfreq;  
  }
}
//----------  BFO out  ---------------   2020.01.05 OZ6YK
void Bfo_out(long frequency){
  if(ifshift != ifshiftb){
    si5351aSetFrequency2(frequency);
    ifshiftb = ifshift;  
  }
}

//---------- meter --------------------------

void meter(){
 meterval1=analogRead(meterin);
 meterval1=meterval1/50;
 if (meterval1>15){meterval1=15;}
  int sx1=sx1+(meterval1*17);
  sx1=sx1+41;
  int sx2=0;
  sx2=sx2+(40+((15-meterval1)*17));
  ucg.setFont(ucg_font_fub35_tr);
  ucg.setColor(0,0,0);
  ucg.drawBox(sx1,180,sx2,16);
  ucg.setPrintPos(40,200);
  for(int i=1;i<=meterval1;i++){
    if (i<=9){
      ucg.setColor(0,255,255);
      ucg.print("-");  
    }
    else{
      ucg.setColor(255,0,0);
      ucg.print("-");
    }
  }
}

//---------- Encoder Interrupt -----------------------

ISR(PCINT2_vect) {
  if (flagrit==1){
  unsigned char result = r.process();
    if(result) {
      if(result == DIR_CW){  
        freqrit=freqrit+fstep;
        if (freqrit>=10000){
          freqrit=10000;
        }
     }
     else{
      freqrit=freqrit-fstep;
      if (freqrit<=-10000){
        freqrit=-10000;
      }
    }
   }
  }
  else{
    unsigned char result = r.process();
      if(result) {
        if(result == DIR_CW){  
          freq=freq+fstep;
          if (freq>=freqmax){freq=freqmax;}
        }
        else{
          freq=freq-fstep;
          if (freq<=freqmin){freq=freqmin;}
        }  
     }
  }
}

//------------ On Air -----------------------------

void txset(){
   // long vfofreq_RX = vfofreq;;
 // long ifshift_RX = ifshift;;
  noInterrupts();
    if (fmode==0){ddsfreq=freq-txshiftLSB;}  // I have chosen to change to freq minus ifshift
    if (fmode==1){ddsfreq=freq-txshiftUSB;}  // because I wanted to be able to go down til the 160m band 
    if (fmode==2){ddsfreq=freq-txshiftCW;}
    if (fmode==3){ddsfreq=freq-txshiftAM;}
ddsfreq=freq+ifshift;                       //  2020.01.05 OZ6YK

    Fnc_Dds(ddsfreq);                       // DDS out  2016/10/24 JA2GQP
    
 Fnc_Dds(ddsfreq);                           // vfo out   2020.01.05 OZ6YK
 Bfo_out(ifshift);                           // BFO out   2020.01.05 OZ6YK
  
    ucg.setPrintPos(250,145);
    ucg.setFont(ucg_font_fub17_tr);
    ucg.setColor(255,0,0);
    ucg.print("TX");
    while(digitalRead(txsw) == LOW){
   
 digitalWrite(txout,HIGH);
 }
 if (digitalRead(txsw) == HIGH) {
digitalWrite(txout,LOW);
   } 
//  vfofreq = vfofreq_RX;
//  ifshift = ifshift_RX;
  
  ucg.setFont(ucg_font_fub17_tr);
    ucg.setColor(0,0,0);
    ucg.drawBox(195,125,280,30);  //45
    ddswrite();
    interrupts();
  }

//------------- Mode change(LSB-USB-CW-AM) ------------

void modeset(){
  ucg.setFont(ucg_font_fub17_tr);
    ucg.setPrintPos(20,82);
    ucg.setColor(0,0,0);
    ucg.print("USB");
 ucg.setPrintPos(20,82);
    ucg.print("LSB"); 
 ucg.setPrintPos(20,82);
    ucg.print("A M");
 ucg.setPrintPos(20,82);
    ucg.print("C W");    
  if (fmode==0){
    ifshift=ifshiftUSB;
    flagmode = 0;    
    ucg.setColor(255,255,0);
  ucg.setPrintPos(20,82);
    ucg.print("USB");

  }
  if(fmode==1){
    ifshift=ifshiftCW;
    flagmode = 1;    
   ucg.setPrintPos(20,82);
    ucg.setColor(255,255,0);
    ucg.print("C W");

  }
  if (fmode==2){
    ifshift=ifshiftAM;
    flagmode = 2;    
    ucg.setPrintPos(20,82);
    ucg.setColor(255,255,0); 
    ucg.print("A M");
 
    }
  if (fmode==3){
    ifshift=ifshiftLSB;
    flagmode = 3;    
    ucg.setPrintPos(20,82);
    ucg.setColor(255,255,0);
    ucg.print("LSB");
 
  }
  fmode=fmode+1;
  if (fmode==4){fmode=0;}
  ddswrite();
  while(analogRead(analogsw) <1000);
}

//------------ Rit SET ------------------------------

void setrit(){
  if(flagrit==0){
    flagrit=1;
    ucg.setFont(ucg_font_fub11_tr);
    ucg.setPrintPos(190,110);
    ucg.setColor(255,0,0);
    ucg.print("RIT");
    ritlcd();
  }
  else {
    flagrit=0;
    ddsfreq=freq-ifshift;


    Fnc_Dds(ddsfreq);                       // DDS Out  2016/10/23 JA2GQP

    freqt=String(freq); 
    ucg.setFont(ucg_font_fub11_tr);
    ucg.setPrintPos(190,110);
    ucg.setColor(255,255,255);
    ucg.print("RIT");
    ucg.setColor(0,0,0);  
    ucg.drawRBox(222,92,91,21,3);
    freqrit=0;
  }
  while(analogRead(analogsw) <1000);
}

//----------- Rit screen ----------------------

void ritlcd(){
  noInterrupts();
  ucg.setColor(0,0,0);  
  ucg.drawBox(222,92,91,21);
  ucg.setFont(ucg_font_fub17_tr);
  ucg.setColor(255,255,255); 
  ucg.setPrintPos(230,110);
  ucg.print(freqrit);
  interrupts();
}

//-------------- encorder frequency step set -----------

void setstep(){
  noInterrupts();
  if (fstep==10000){
    fstep=10;
  }
  else{
    fstep=fstep * 10;
  } 
 steplcd(); 
 while(analogRead(analogsw) < 1000);
 interrupts();
}

//------------- Step Screen ---------------------------

void steplcd(){
  ucg.setColor(0,0,0);
  ucg.drawRBox(221,61,93,23,3);
  ucg.setFont(ucg_font_fub17_tr);
  ucg.setColor(255,255,255);
  ucg.setPrintPos(220,80);
  if (fstep==10){ucg.print("    10Hz");}
  if (fstep==100){ucg.print("   100Hz");}
  if (fstep==1000){ucg.print("    1KHz");}
  if (fstep==10000){ucg.print("  10KHz");} 
}

//----------- Main frequency screen -------------------

void freqlcd(){
  ucg.setFont(ucg_font_fub35_tn); 
  int mojisuu=(freqt.length());
  if(freq<100){
    ucg.setColor(0,0,0);
    ucg.drawBox(217,9,28,36);     
  }
  if(f10 !=(freqt.charAt(mojisuu-2))){
    ucg.setColor(0,0,0);
    ucg.drawBox(245,9,28,36);
    ucg.setPrintPos(245,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-2)); 
    f10 = (freqt.charAt(mojisuu-2));
  }

  if(freq<1000){
    ucg.setColor(0,0,0);
    ucg.drawBox(202,9,15,36);        
    }
  if(f100 !=(freqt.charAt(mojisuu-3))){
    ucg.setColor(0,0,0);
    ucg.drawBox(217,9,28,36);
    ucg.setPrintPos(217,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-3)); 
    f100 = (freqt.charAt(mojisuu-3));
  }
  if(freq>=1000){
    ucg.setPrintPos(202,45);
    ucg.setColor(0,255,0);
    ucg.print(".");
  }
  if(freq<10000){
    ucg.setColor(0,0,0);
    ucg.drawBox(146,9,28,36);     
    }
  if(f1k !=(freqt.charAt(mojisuu-4))){
    ucg.setColor(0,0,0);
    ucg.drawBox(174,9,28,36);
    ucg.setPrintPos(174,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-4));       
    f1k  = (freqt.charAt(mojisuu-4));
  }
  if(freq<100000){
    ucg.setColor(0,0,0);
    ucg.drawBox(118,9,28,36); 
  }
  if(f10k !=(freqt.charAt(mojisuu-5))){
    ucg.setColor(0,0,0);
    ucg.drawBox(146,9,28,36);
    ucg.setPrintPos(146,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-5));   
    f10k = (freqt.charAt(mojisuu-5));
  }
   if(freq<1000000){
    ucg.setColor(0,0,0);
    ucg.drawBox(103,9,15,36); 
    }
  if(f100k !=(freqt.charAt(mojisuu-6))){
    ucg.setColor(0,0,0);
    ucg.drawBox(118,9,28,36);
    ucg.setPrintPos(118,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-6));   
    f100k = (freqt.charAt(mojisuu-6));
  }
       
   if(freq>=1000000){
    ucg.setPrintPos(103,45);
    ucg.setColor(0,255,0);
    ucg.print(".");
  }
   if(freq<10000000){
     ucg.setColor(0,0,0);
    ucg.drawBox(47,9,28,36);
     }
   if(fmega !=(freqt.charAt(mojisuu-7))){
    ucg.setColor(0,0,0);
    ucg.drawBox(75,9,28,36);
    ucg .setPrintPos(75,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-7));   
    fmega  = (freqt.charAt(mojisuu-7));
   }
   if(freq<100000000){
    ucg.setColor(0,0,0);
    ucg.drawBox(19,9,28,36);
       }
   if (f10m !=(freqt.charAt(mojisuu-8))){
    ucg.setColor(0,0,0);
    ucg.drawBox(47,9,28,36);
    ucg .setPrintPos(47,45);
    ucg.setColor(0,255,0);
    ucg.print(freqt.charAt(mojisuu-8));
    f10m = (freqt.charAt(mojisuu-8));
   }



}
//----------- Basic Screen -------------------------

void screen01(){
  ucg.setColor(255,255,255);
  ucg.drawRFrame(1,1,314,55,5);
  ucg.drawRFrame(2,2,312,53,5);
  ucg.setColor(50,50,50);
  ucg.drawRBox(5,60,60,25,3);
 
  ucg.setFont(ucg_font_fub17_tr);
  ucg.setPrintPos(20,82);
  ucg.setColor(0,0,0);
  ucg.print("LSB");
  ucg.setPrintPos(20,82);
  ucg.print("USB");
 ucg.setPrintPos(20,82);
  ucg.print("C W");
 ucg.setPrintPos(20,82);
  ucg.print("A M"); 
  ucg.setColor(255,255,255);
  ucg.drawRFrame(220,60,95,25,3);
  ucg.drawRFrame(220,90,95,25,3);
  ucg.setFont(ucg_font_fub11_tr);
  ucg.setColor(255,255,255);
  ucg.setPrintPos(175,80);
  ucg.print("STEP");
  ucg.setPrintPos(190,110);
  ucg.setColor(255,255,255);
  ucg.print("RIT");
  ucg.setColor(249, 231, 159);
  ucg.setPrintPos(10,210);
  ucg.print(" S:  1-----3-------6-------9---Over--------");
// ucg.setPrintPos(10,177);
 // ucg.print(" P:  1-----3-----5-----------10--------------"); 
  ucg.setPrintPos(50,235);
  ucg.setColor(235,0,200);
  ucg.print("OZ6YK 70 Mhz DDS TRX "); 
  ucg.setFont(ucg_font_fub35_tr);
    ucg.setColor(0,255,0);
    ucg.setPrintPos(273,45);
    ucg.print("0");    
}

//---------- DDS Frequency write -----------

void ddswrite(){
  if (flagrit==0){
    if(hetero == UPPER)
      ddsfreq=freq+ifshift;
    else
      ddsfreq=ifshift-freq;
    Fnc_Dds(ddsfreq);                               // DDS out  2016/10/24 JA2GQP
  }

  if(flagrit==1){                                  // BFO    2020.01.05 OZ6YK
    if(hetero == UPPER)
      ddsfreq=freq+ifshift-freqrit;
    else
      ddsfreq=ifshift-freqrit+freq;  
    Fnc_Dds(ddsfreq);                              // DDS out
  }
  Bfo_out(ifshift);                                // BFO    2020.01.05 OZ6YK
}



 //---------- EEPROM Write(4byte) subroutine ----------
 
void eepwrite(unsigned long f0,int epadd){
  for (int i=0; i<=3;i++){
  EEPROM.write(epadd+i,f0%256);
  f0=f0/256;
  }
}

//---------- EEPROM Read(4byte) subroutin ----------

unsigned long eepread(int epadd){
  unsigned long f0=0;
  for (int i=3; i >=0 ;i--){
    f0=f0*256+EEPROM.read(epadd+i);
    }
    return f0;
}
