/*
 *     Arduino VFO Initial data writer
 *                          for DDS VFO Ver3         
 *                         JA2NKD 2016.10.18     
 *                         Alterd by OZ6YK 2022.09.12 to use for 50 and 70 Mhz
 *                         This file must be uploaded before the 4m file.
 *     Aruduino IDE 1.6.5
 *     Arduino nano only
 *     
 * <Rotary.h>    https://github.com/brianlow/Rotary
 * <EF_AD9850.h> http://forum.arduino.cc/index.php?topic=77483.0
 * "Ucglib.h"    https://github.com/olikraus/ucglib
 *
 */

// Library include
#include <SPI.h>
#include <EEPROM.h>
#include <Ucglib.h>

/*
 * Hardware SPI Pins:
 * Arduino nano sclk=13, data=11
 * 
*/

// I/O setting 

  const byte __CS=10;
  const byte __DC=9;
  const byte __RST=8;
  
Ucglib_ILI9341_18x240x320_HWSPI ucg(__DC, __CS, __RST);

// Variable setting
  unsigned long freq[4];
  int romadd=0x100;
  int fstep=100;
  int fmode=1;


 
void setup() {

ucg.begin(UCG_FONT_MODE_TRANSPARENT);
ucg.clearScreen();
ucg.setRotate270();
ucg.setFont(ucg_font_ncenR14_tr);
ucg.setPrintPos(10,20);
ucg.setColor(255,0,0);
ucg.print("Hello");
ucg.setPrintPos(10,40);
ucg.setColor(0,255,255);
ucg.print("NKD_VFO ROM Write & Read test");

EEPROM.write(0x01,1);   //Power On BAND (0 to 9) 

// BAND:0 ROMadd:0x010 50 Mhz
  romadd=0x010;
  freq[0]=52800000;
  freq[1]=50000000;
  freq[2]=55000000;
  fmode=0;
  fstep=2;
  bandwrite();
  
// BAND:1 ROMadd:0x020 70 Mhz
  romadd=0x020;
  freq[0]=70200000;
  freq[1]=69800000;
  freq[2]=71000000;
  fmode=0;
  fstep=2;
  bandwrite();

// Read test 
  ucg.setColor(255,255,255);
  for(int z=0; z<8; z++){
    romadd=0x10+(0x10*z);
    for (int i=0; i<3;i++){
      freq[i]=eepread((romadd+4*i));
    }
    fmode=EEPROM.read(romadd+12);
    fstep=EEPROM.read(romadd+13);
    ucg.setPrintPos(10,70+(20*z));
    for (int i=0; i<3;i++){
      ucg.print(freq[i]);
      ucg.print(" ");
    }
    ucg.print(fmode);
      ucg.print(" ");
    ucg.print(fstep);
  }
}
//Main Routine
void loop() {

}

 void bandwrite(){
  for (int i=0;i<3;i++){
 //   romadd=romadd+4;
    eepwrite(freq[i],(romadd+4*i));
  }
  EEPROM.write(romadd+12,fmode);
  EEPROM.write(romadd+13,fstep);
 }
 
void eepwrite(unsigned long f0,int epadd){
  for (int i=0; i<=3;i++){
  EEPROM.write(epadd+i,f0%256);
  f0=f0/256;
  }
}

unsigned long eepread(int epadd){
  unsigned long f0=0;
  for (int i=3; i >=0 ;i--){
    f0=f0*256+EEPROM.read(epadd+i);
    }
return f0;
}
